// MP5SeriesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MP5Series.h"
#include "MP5SeriesDlg.h"

#include "crc.h"


#define	MP5_SEND_PACKET_SIZE	20



#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP5SeriesDlg dialog
CMP5SeriesDlg::CMP5SeriesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMP5SeriesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMP5SeriesDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMP5SeriesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMP5SeriesDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_STATIC_ETXCRC, m_ETXCRC);
	DDX_Control(pDX, IDC_STATIC_FRONT, m_Frame);
	DDX_Control(pDX, IDC_EDIT_RECEIVE_MESSAGE, m_ReceiveMsg);
	DDX_Control(pDX, IDC_EDIT_SEND_MESSAGE, m_SendMsg);
	DDX_Control(pDX, IDC_COMBO_ADDR, m_AddrList);
	DDX_Control(pDX, IDC_CHECK_BANK, m_Bank);
	DDX_Control(pDX, IDC_CHECK_PNP, m_PNP);
	DDX_Control(pDX, IDC_CHECK_AUTO, m_Auto);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMP5SeriesDlg, CDialog)
	//{{AFX_MSG_MAP(CMP5SeriesDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	ON_BN_CLICKED(IDC_STATIC_FRONT, OnStaticFront)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CHECK_AUTO, OnCheckAuto)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP5SeriesDlg message handlers

BOOL CMP5SeriesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//    ʱȭ
	m_Comm_Port = 0;		// COM1
	m_Comm_Baudrate = 6;	// 9600
	m_Comm_ParityBit = 0;	// NOPARITY
	m_Comm_DataBit = 1;		// 8
	m_Comm_StopBit = 0;		// ONESTOPBIT

	// fnd ʱȭ
	m_FND.SetFrame(&m_Frame);
	m_FND.SetColor(1);
	sprintf(m_FND_Value, "%5.0f", 0);

	// led ʱȭ
	m_LED.SetFrame(&m_Frame);
	m_LED.SetMode(2);

	// ȭ鿡 ǥ Dialog item ʱȭ
	m_Auto.SetCheck(1);
	m_PNP.SetCheck(1);
	m_Bank.SetCheck(0);
	OnCheckAuto();

	//  ʱȭ
	m_Unit = "Sec";

	//    ʱȭ
	Init();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMP5SeriesDlg::Init()
{
	DWORD baudrate_map[15] = {	CBR_110,CBR_300,CBR_600,CBR_1200,CBR_2400,
								CBR_4800,CBR_9600,CBR_14400,CBR_19200,CBR_38400,
								CBR_56000,CBR_57600,CBR_115200,CBR_128000,CBR_256000 };
	BYTE databit_map[2] = {7,8};
	BYTE stopbit_map[2] = {ONESTOPBIT,TWOSTOPBITS};
	BYTE paritybit_map[3] = {NOPARITY,ODDPARITY,EVENPARITY};

	if(!m_comm.Open(m_Comm_Port+1,
				baudrate_map[m_Comm_Baudrate],
				databit_map[m_Comm_DataBit],
				paritybit_map[m_Comm_ParityBit],
				stopbit_map[m_Comm_StopBit]))
	{
		CString str;
		str.Format("COM%d can't open!", m_Comm_Port+1);
		AfxMessageBox(str);
	}


	memset(m_Addr, 0, sizeof(char)*MP5_MAX_NUM);
	for(int i=0;i<MP5_MAX_NUM;i++)
		m_Addr[i] = -1;

	m_AddrCurrIndex = 0;
	m_AddrRequest = -1;
	m_MaxNum = 0;

	m_Request = FALSE;
	m_MainRequest = TRUE;
}

void CMP5SeriesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMP5SeriesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// ȭ鿡 FND 
		m_FND.Refresh(73,34,m_FND_Value);

		//  
		m_FND.Unit(206,49,m_Unit);

		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMP5SeriesDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMP5SeriesDlg::OnButtonSend() 
{
	// TODO: Add your control notification handler code here
	BYTE msg[64];
	char out[64];
	CString str;

	// Ŷ   о
	m_comm.Read(msg, 60);			// dummy read

	memset(msg, 0xff, 64);

	// TX LED ѱ
	m_LED.Refresh(4,85,1);

	// Էâκ  б
	m_SendMsg.GetWindowText(str);
	sprintf((char*)msg,"\002%s\003 ",(LPCTSTR)str);

	// CRC
	msg[17] = CRC8table_packet(msg+1, 16);

	// CRC ȭ鿡 ǥ
	sprintf(out, "ETX,%02X", msg[17]);
	m_ETXCRC.SetWindowText(out);

	// Ŷο 
	m_comm.Write(msg, MP5_SEND_PACKET_SIZE+15);			// write

	// TX/RX LED 
	m_LED.Refresh(4,85,2);
	m_LED.Refresh(4,91,2);

	//  ٸ
	Sleep(1000);						// wait

	// Ŷ б
	ReadPacket();					// read
}

static const char *g_Code[] =
	{"P0","C0","C1","C2","C3","K0","K1","X0","X1","Y0","Y1",NULL};
static const char *g_Command[] = 
	{"RX","RD","WX","WD",NULL};

int CMP5SeriesDlg::SendPacket(int addr, int command, int bank, int code, double value)
{
	BYTE msg[64];
	char out[64];

	//  Ŷ б
	m_comm.Read(msg, 64);

	memset(msg,0xff,64);

	// TX LEDѱ
	m_LED.Refresh(4,85,1);

	// Ŷ 
	sprintf((char*)msg,"\002%02d%s%1d%s%+07.0f0\003 ",
		addr,
		g_Command[command],
		bank,
		g_Code[code],
		value);

	// CRC
	msg[17] = CRC8table_packet(msg+1, 16);

	// Ŷ ȭ鿡 ǥ
	sprintf(out, "ETX,%02X", msg[17]);
	m_ETXCRC.SetWindowText(out);

	memcpy(out, msg+1, 15);
	out[15]=0;
	m_SendMsg.SetWindowText(out);

	// Ŷο Ŷ 
	m_comm.Write(msg, MP5_SEND_PACKET_SIZE+15);			// write

	// TX/RX LED
	m_LED.Refresh(4,91,2);
	m_LED.Refresh(4,85,2);

	return 1;
}

int CMP5SeriesDlg::ReadPacket(stValue* parameter)
{
	char out[32];
	CString str;
	int i, len;
	BYTE packet[64];


	// Ŷ б
	len = m_comm.Read(packet, 60);

	// Ŷ 簪 ǥ
	for(i=0;i<len;i++)
	{
		sprintf(out,"%02X ", packet[i]);
		str += out;
	}
	m_ReceiveMsg.SetWindowText(str);

	// CRC8˻
	if( CRC8table_packet(packet+2, 16)==packet[18] && len>18 )
	{
		//  
		float a;
		long exp;
		int k, sign, digit, dot, codeindex, bank, addr, index;


		// ACKȣ ˻
		if(packet[0]!=0x06) return FALSE;			// ACK(0x06)

		// STXȣ ˻
		if(packet[1]!=0x02) return FALSE;			// STX(0x02)

		// Command ˻
		if(memcmp(packet+4,"RD",2)) return FALSE;	// "RD" only

		// Code ã
		for(k=0;g_Code[k];k++)
		{
			if( !memcmp(g_Code[k], packet+7, 2) )
				break;
		}
		if(k>=11) return FALSE;
		codeindex = k;


		// (address) 
		addr = (packet[2]-'0')*10 + (packet[3]-'0');
		if(addr<0 || addr>=MP5_MAX_NUM) return FALSE;

		// Bankȣ 
		bank = packet[6]-'0';

		// RX LED ѱ
		m_LED.Refresh(4,91,1);

		// ȣ(sign) 
		sign = packet[9]=='-' ? -1 : 1;

		// Value 
		digit = 5;
		dot = packet[16]-'0';
		if(dot) digit++;
		a = 0;
		exp=100000;
		for(k=0;k<6;k++)
		{
			a += (packet[k+10]-'0') * exp;
			exp /= 10;
		}
		for(k=0;k<dot;k++)
			a /= 10;
		a *= sign;

		// PNP
		PNPList(addr, TRUE);

		// Ķ 
		if(parameter)
			parameter->addr = addr;

		switch(codeindex) {
		case 0:		// P0
			if(parameter)
				parameter->value = a;

			str.Format("%02d",addr);
			index = m_AddrList.FindString(0,(LPCTSTR)str);
			if(m_Bank.GetCheck()==bank && index==m_AddrList.GetCurSel() )
			{
				sprintf(m_FND_Value, "%*.*f", digit, dot, a);
				m_FND.Refresh(73,34,m_FND_Value);
			}
			break;
		case 1:		// C0
			if(parameter) parameter->hh = a;
			break;
		case 2:		// C1
			if(parameter) parameter->h = a;
			break;
		case 3:		// C2
			if(parameter) parameter->l = a;
			break;
		case 4:		// C3
			if(parameter) parameter->ll = a;
			break;
		case 5:		// K0
			if(parameter) parameter->peak_max = a;
			break;
		case 6:		// K1
			if(parameter) parameter->peak_min = a;
			break;
		case 7:		// X0
			if(parameter) parameter->prescale_x_a = a;
			break;
		case 8:		// X1
			if(parameter) parameter->prescale_x_b = a;
			break;
		case 9:		// Y0
			if(parameter) parameter->prescale_y_a = a;
			break;
		case 10:	// Y1
			if(parameter) parameter->prescale_y_b = a;
			break;
		default:
			return FALSE;
		}

		return TRUE;
	}
	else
	{
		// PNP
		PNPList(m_AddrRequest, FALSE);

		// RX ȲLEDѱ
		m_LED.Refresh(4,91,3);
	}

	return FALSE;
}

void CMP5SeriesDlg::PNPList(int addr, int stat)
{
	CString str;
	str.Format("%02d",addr);
	int index;

	// LIST ش addr˻
	index = m_AddrList.FindString(0,(LPCTSTR)str);

	// addr   
	if(addr<0 || addr>=MP5_MAX_NUM)
		return;

	// LIST ε  
	if(index==CB_ERR)
	{
		// Ͽ ߰
		if(stat)
		{
			// add list
			m_Addr[addr] = addr;
			m_AddrList.AddString(str);
			if(m_AddrList.GetCurSel()<0)
				m_AddrList.SetCurSel( m_AddrList.FindString(0,(LPCTSTR)str) );
		}
	}

	// LIST ε  
	else
	{
		// Ͽ 
		if(!stat)
		{
			// delete list
			m_Addr[addr] = -1;
			m_AddrList.DeleteString(index);
			m_AddrList.SetCurSel(0);
		}
	}

	m_MaxNum = m_AddrList.GetCount();
}

void CMP5SeriesDlg::OnTimer(UINT nIDEvent) 
{
	CString str;
	int bank, pnp;


	// TODO: Add your message handler code here and/or call default
	switch(nIDEvent) {
	case 0:
		// û ̸
		if(!m_Request)
		{
			bank = m_Bank.GetCheck();
			pnp = m_PNP.GetCheck();
			// PNPó
			if(pnp)
			{
				if(m_MainRequest && m_MaxNum)
				{
					m_AddrList.GetWindowText(str);
					m_AddrRequest = atoi(str);
					m_MainRequest = FALSE;
				}
				else
				{
					m_AddrCurrIndex++;
					if(m_AddrCurrIndex>=MP5_MAX_NUM) m_AddrCurrIndex=0;
					m_AddrRequest = m_AddrCurrIndex;
					m_MainRequest = TRUE;
				}
			}
			else
			{
				m_AddrList.GetWindowText(str);
				m_AddrRequest = atoi(str);
			}

			// Ŷ 
			SendPacket(
				m_AddrRequest,
				0,	// RX
				bank,
				0,	// P0
				0.0);

			m_Request = TRUE;
		}

		//  ̸
		else
		{
			// Ŷ б
			ReadPacket();
			m_Request = FALSE;
		}
		break;

	default:
		break;
	}

	// ȭ鿡 FND 
	m_FND.Refresh(73,34,m_FND_Value);

	//  
	m_FND.Unit(206,49,m_Unit);

	CDialog::OnTimer(nIDEvent);
}

void CMP5SeriesDlg::Pause()
{
	KillTimer(0);
}

// Autoscan  Ǿ  ȣ!
void CMP5SeriesDlg::Restart()
{
	SetTimer(0, 700, NULL);

	m_Request = FALSE;
	m_MainRequest = TRUE;
}

// ü Ķ͸ д´
int CMP5SeriesDlg::ParameterLoad(void* parameter, CProgressCtrl* pProgress)
{
	int i, bank, addr;
	CString str;
	BYTE msg[100];

	if(!parameter) return FALSE;

	// Autoscan  
	if(m_Auto.GetCheck())
		Pause();

	// Ŷο  ð  ش.
	Sleep(500);

	// Ŷο   о
	m_comm.Read(msg, 100);	// dummy read

	// α׷  
	if(pProgress)
		pProgress->SetRange(0,10);

	//  õ address()б
	m_AddrList.GetWindowText(str);
	addr = atoi(str);

	// bank б
	bank = m_Bank.GetCheck();

	//  11 Ķ б
	for(i=0;i<11;i++)
	{
		// Ŷ 
		SendPacket(	addr, 0, bank, i, 0.0);

		//  ٸ
		Sleep(700);

		// Ŷ б
		ReadPacket((stValue*)parameter);

		// α׷  ġ 
		if(pProgress)
			pProgress->SetPos(i+1);
	}

	// Autoscan 簳
	if(m_Auto.GetCheck())
		Restart();

	// α׷  ġ ʱȭ
	if(pProgress)
		pProgress->SetPos(0);

	return 0;
}

void CMP5SeriesDlg::OnCheckAuto() 
{
	CButton* pSendBtn = (CButton*)GetDlgItem(IDC_BUTTON_SEND);
	CEdit* pSendEdit = (CEdit*)GetDlgItem(IDC_EDIT_SEND_MESSAGE);
	CEdit* pPNPEdit = (CEdit*)GetDlgItem(IDC_CHECK_PNP);

	// TODO: Add your control notification handler code here
	// Autoscan  б
	int stat = m_Auto.GetCheck();

	// üũ  ִٸ
	if( stat )
	{
		// 簳
		Restart();
		// Dialog item Disable/Enable 
		pSendBtn->EnableWindow(FALSE);
		pSendEdit->EnableWindow(FALSE);
		pPNPEdit->EnableWindow(TRUE);
	}
	else
	{
		// 
		Pause();
		// Dialog item Disable/Enable 
		pSendBtn->EnableWindow(TRUE);
		pSendEdit->EnableWindow(TRUE);
		pPNPEdit->EnableWindow(FALSE);
	}
}

void CMP5SeriesDlg::Close()
{
	// Autoscan϶ Ÿ̸Ӹ 
	KillTimer(0);
	// Ŷ 
	m_comm.Close();
}

// α׷ ó!
BOOL CMP5SeriesDlg::DestroyWindow() 
{
	// ó
	Close();

	// FND ó
	m_FND.Close();

	// LED ó
	m_LED.Close();

	return CDialog::DestroyWindow();
}

#include "Setup.h"
void CMP5SeriesDlg::OnStaticFront() 
{
	CSetup dlg;


	//  Ķ   ȭڷ 
	dlg.m_Port = m_Comm_Port;
	dlg.m_BaudRate = m_Comm_Baudrate;
	dlg.m_DataBit = m_Comm_DataBit;
	dlg.m_ParityBit = m_Comm_ParityBit;
	dlg.m_StopBit = m_Comm_StopBit;
	dlg.m_Unit = m_Unit;
	m_AddrList.GetWindowText(dlg.m_Addr);
	dlg.m_Bank.Format("%d", m_Bank.GetCheck());
	dlg.m_pMP5SeriesDlg = this;
	if(dlg.DoModal()==IDOK)
	{
		// Ŷ  ȭ ִٸ
		if(	m_Comm_Port != dlg.m_Port ||
			m_Comm_Baudrate != dlg.m_BaudRate ||
			m_Comm_DataBit != dlg.m_DataBit ||
			m_Comm_ParityBit != dlg.m_ParityBit ||
			m_Comm_StopBit != dlg.m_StopBit )
		{
			//  
			m_Comm_Port = dlg.m_Port;
			m_Comm_Baudrate = dlg.m_BaudRate;
			m_Comm_DataBit = dlg.m_DataBit;
			m_Comm_ParityBit = dlg.m_ParityBit;
			m_Comm_StopBit = dlg.m_StopBit;

			// ó
			Close();

			// ʱȭ
			Init();

			// Autoscan 
			if(m_Auto.GetCheck())
				Restart();
		}

		//  
		m_Unit = dlg.m_Unit;
	}
}
